#include <ESP8266WiFi.h>
#include <ESP8266WebServer.h>

/*Ağ adınızı ve Şifrenizi Giriniz*/
const char* kablosuzAgAdi = "ZyXEL";  // Ağ adınızı girin
const char* sifre = "CK4YTTFPACTL";  //Ağ şifrenizi girin

ESP8266WebServer server(80); //80 portunu kullanarak bir webserver nesnesi oluşturduk

const byte LED1 = D4; // GPIO2 pini D4 pini çıkış. (Dahili LED.)
bool LED1durum = LOW;

const byte LED2 = D6;
bool LED2durum = LOW;

void setup() {
  Serial.begin(9600);
  delay(100);
  pinMode(LED1, OUTPUT);
  pinMode(LED2, OUTPUT);


  Serial.println(kablosuzAgAdi);
  Serial.println(" Ağına Bağlanılıyor");

  //yerel ağınıza bağlanmanız için gerekli komut
  WiFi.begin(kablosuzAgAdi, sifre);

  //bağlantının gerçekleştiğini kontrol ediyoruz
  while (WiFi.status() != WL_CONNECTED) {
    delay(1000);
    Serial.print("."); //gerçekleşene kadar loading gibi işaret yaptırıyoruz
  }
  Serial.println("");
  Serial.println("Ağ Bağlantısı Sağlandı..!");
  Serial.print("IP Adresiniz: ");  Serial.println(WiFi.localIP());

  server.on("/", bagli);
  server.on("/led1on", LED1acik);
  server.on("/led1off", LED1kapali);
  server.on("/led2on", LED2acik);
  server.on("/led2off", LED2kapali);
  server.onNotFound(sayfaBulunamadi);

  server.begin();
  Serial.println("HTTP Sunucusu Başlatıldı");
}
void loop() {
  server.handleClient();
  if (LED1durum)
  {
    digitalWrite(LED1, HIGH);
  }
  else
  {
    digitalWrite(LED1, LOW);
  }

  if (LED2durum)
  {
    digitalWrite(LED2, HIGH);
  }
  else
  {
    digitalWrite(LED2, LOW);
  }
}

void bagli() {
  LED1durum = LOW;
  LED2durum = LOW;
  Serial.println("GPIO7 Durumu: KAPALI | GPIO6 Durumu: KAPALI");
  server.send(200, "text/html", HTML(LED1durum, LED2durum));
}
void led1on() {
  LED1durum = LOW; // NodeMCU 1.0 (ESP-12E) D4 pini. Dahili LED aktif 0'dır.
  Serial.println("GPIO7 Durumu: AÇIK");
  server.send(200, "text/html", HTML(true, LED2durum));
}
void led1off() {
  LED1durum = HIGH;
  Serial.println("GPIO7 Durumu: KAPALI");
  server.send(200, "text/html", HTML(false, LED2durum));
}


void LED1acik() {
  LED1durum = HIGH;
  Serial.println("GPIO7 Durumu: AÇIK");
  server.send(200, "text/html", HTML(true, LED2durum));
}

void LED1kapali() {
  LED1durum = LOW;
  Serial.println("GPIO7 Durumu: KAPALI");
  server.send(200, "text/html", HTML(false, LED2durum));
}

void LED2acik() {
  LED2durum = HIGH;
  Serial.println("GPIO6 Durumu: AÇIK");
  server.send(200, "text/html", HTML(LED1durum, true));
}

void LED2kapali() {
  LED2durum = LOW;
  Serial.println("GPIO6 Durumu: KAPALI");
  server.send(200, "text/html", HTML(LED1durum, false));
}

void sayfaBulunamadi() {
  server.send(404, "text/plain", "Sayfa Bulunamadı");
}

String HTML(uint8_t led1Durum, uint8_t led2Durum) {
  String metin = "<!DOCTYPE html> <html>\n";
  metin += "<head><meta name=\"viewport\" content=\"width=device-width, initial-scale=1.0, user-scalable=no\">\n";
  metin += "<meta http-equiv=\"Content-Type\" content=\"text/html;charset=UTF-8\">";
  metin += "<title>LED ve Röle Kontrol</title>\n";
  metin += "<style>html { font-family: Helvetica; display: inline-block; margin: 0px auto; text-align: center;}\n";
  metin += "body{margin-top: 50px;} h1 {color: #444444;margin: 50px auto 30px;} h3 {color: #444444;margin-bottom: 50px;}\n";
  metin += ".button {display: block;width: 80px;background-color: #1abc9c;border: none;color: white;padding: 13px 30px;text-decoration: none;font-size: 25px;margin: 0px auto 35px;cursor: pointer;border-radius: 4px;}\n";
  metin += ".button-on {background-color: #1abc9c;}\n";
  metin += ".button-on:active {background-color: #16a085;}\n";
  metin += ".button-off {background-color: #34495e;}\n";
  metin += ".button-off:active {background-color: #2c3e50;}\n";
  metin += "p {font-size: 14px;color: #888;margin-bottom: 10px;}\n";
  metin += "</style>\n";
  metin += "</head>\n";
  metin += "<body>\n";
  metin += "<h1>ESP8266 Web Server Uygulaması</h1>\n";
  metin += "<h3>ESP Station(STA) Modunda Kullanılıyor</h3>\n";

  if (led1Durum)
  {
    metin += "<p>LED1 Durum: AÇIK</p><a class=\"button button-off\" href=\"/led1off\">KAPAT</a>\n";
  }
  else
  {
    metin += "<p>LED1 Durum: KAPALI</p><a class=\"button button-on\" href=\"/led1on\">AÇ</a>\n";
  }

  if (led2Durum)
  {
    metin += "<p>LED2 Durum: AÇIK</p><a class=\"button button-off\" href=\"/led2off\">KAPAT</a>\n";
  }
  else
  {
    metin += "<p>LED2 Durum: KAPALI</p><a class=\"button button-on\" href=\"/led2on\">AÇ</a>\n";
  }

  metin += "</body>\n";
  metin += "</html>\n";
  return metin;
}
